Subject: Some Concerns

From: [email-masked] (Jim Stewart)
Date: Tue, 3 Mar 92 23:28:37 PST

I have a couple of concerns about the implementation of ps on
tsx-11.mit.edu.  The work done is of high quality, and returns
handy information, *however*:

1) The use of a ps specific database of kernel symbols is IMHO a mistake.  
   I prefer to use nlist and the system image.  I do not intend to boot
   from floppy forever, and if the image is available I vote that it be
   used.

2) The number of patches to the kernel required to support instrumentation
   for this command scares me.  I am uncomfortable with the notion of adding
   individual fields to to the structures in an ad hoc fashion. 

With respect to the first point: 

   + I think that an official decision must be made soon as to the name 
     of the system image in the root directory.  

   + Second, the default for the linux Makefile build should be changed 
     to NOT strip symbols.  

   + Third, <nlist.h> and nlist(3) should be added to libc.a in the standard 
     distribution.   

With respect to the second point:

   + A small collection of standard structures can be defined for 
    performance metering:

	- struct vmmeter {...} and <sys/vmmeter.h> for memory 
	- struct psmeter {...} and <sys/psmeter.h> for tasks
        - struct iometer {...} and <sys/iometer.h> for io
        - ?

   + The goal of this work should be to localize changes to the kernel
     for performance monitoring, with an eye to adding both conditional
     inclusion and syscall access to this information.  

If we do not do something about this now, we can expect a proliferation
of incompatible "sbin" utilities that will be so patch level dependent
as to be of little use to the general community.

js